const translations = {
  en: {
    allVersions: 'All versions',
    allowedValues: 'Allowed values',
    compareTo: 'Compare to',
    connect: 'Connect',
    defaultValue: 'Default value',
    description: 'Description',
    disconnect: 'Disconnect',
    errorExample: 'Error example',
    errorResponse: 'Error response',
    field: 'Field',
    header: 'Header',
    headerExample: 'Header example',
    hideHints: 'Hide hints',
    mainChapter: 'Main chapter',
    name: 'Name',
    optional: 'optional',
    parameter: 'Parameter',
    parameterExample: 'Parameter example',
    parameterValue: 'Parameter value',
    preset: 'Preset',
    response: 'Response',
    send: 'Send',
    sendSampleRequest: 'Send sample request',
    showHints: 'Show hints',
    successExample: 'Success example',
    type: 'Type',
    usageExample: 'Usage example',
    value: 'Value',
    variable: 'Variable',
  },
  he: {
    allVersions: 'כל הגרסאות',
    allowedValues: 'Allowed values',
    compareTo: '-השווה ל',
    connect: 'התחבר',
    defaultValue: 'Default value',
    description: 'תיאור',
    disconnect: 'להתנתק',
    errorExample: 'Error example',
    errorResponse: 'תגובת שגיאה',
    field: 'שדה',
    header: 'כותרת',
    headerExample: 'דוגמה לכותרת',
    hideHints: 'הסתר רמזים',
    mainChapter: 'פרק ראשי',
    name: 'שם',
    optional: 'optional',
    parameter: 'פרמטר',
    parameterExample: 'דוגמא לפרמטרים',
    parameterValue: 'ערך פרמטר',
    preset: 'Preset',
    response: 'תגובה',
    send: 'שלח',
    sendSampleRequest: 'שלח קריאת דוגמא',
    showHints: 'הצג רמזים',
    successExample: 'Success example',
    type: 'סוג',
    usageExample: 'דוגמה לשימוש',
    value: 'ערך',
    variable: 'משתנה',
  },
  ru: {
    allVersions: 'Все версии',
    allowedValues: 'Допустимые значения',
    compareTo: 'Сравнить с',
    connect: 'Подключиться',
    defaultValue: 'По умолчанию',
    description: 'Описание',
    disconnect: 'Отключиться',
    errorExample: 'Пример ошибочного ответа',
    errorResponse: 'Ошибочный ответ',
    field: 'Поле',
    header: 'Заголовок',
    headerExample: 'Пример заголовков',
    hideHints: 'Свернуть',
    mainChapter: 'Основная глава',
    name: 'Имя',
    optional: 'опциональное',
    parameter: 'Параметр',
    parameterExample: 'Пример параметров',
    parameterValue: 'Значение параметра',
    preset: 'Сохраненный запрос',
    response: 'Ответ',
    send: 'Отправить',
    sendSampleRequest: 'Отправить тестовый запрос',
    showHints: 'Развернуть',
    successExample: 'Пример успешного ответа',
    type: 'Тип',
    usageExample: 'Пример использования',
    value: 'Значение',
    variable: 'Переменная',
  },
  zh: {
    allVersions: '所有版本',
    allowedValues: 'Allowed values',
    compareTo: '相比于',
    connect: '连接',
    defaultValue: 'Default value',
    description: '描述',
    disconnect: '断开',
    errorExample: 'Error example',
    errorResponse: '错误回应',
    field: '领域',
    header: '标头',
    headerExample: '标头示例',
    hideHints: '隐藏提示',
    mainChapter: '本章',
    name: '名称',
    optional: 'optional',
    parameter: '名称',
    parameterExample: '参数示例',
    parameterValue: '参数值',
    preset: 'Preset',
    response: '响应',
    send: '发送',
    sendSampleRequest: '发送样品申请',
    showHints: '显示提示',
    successExample: 'Success example',
    type: '类型',
    usageExample: 'Usage example',
    value: '值',
    variable: '变量',
  },
};

if (typeof module !== 'undefined') {
  module.exports.translations = translations;
}
